#include "gpio.h"

void msg_init();
void msg_proc();
void msg_putc(const char);
void msg_puts(const char *);

char argbuf[256];

void c_main(int __argc, char *__argv[]) {
	int i=1;
	char *p,*q;
	char *argv[10];
	argv[0] = NULL;

	if ((__argc > 1) && __argv[1]) {
		strncpy(argbuf, __argv[1], 256);
		argbuf[255] = 0;
		*p = argbuf;
		q = p;
		while (*p) {
		    while (*q && *q != ' ') q++;
		    if (q != p) {
			argv[i++] = p;
			if (*q == ' ') *q = 0;
			p = q + 1;
			q = p;
		    }
		}
	}
}

void c_main(int argc, char *argv[]) {
	int i;
	char *p;
	int pin;

	pin = 2 * 32 + 15; /* PC15/PWM5 -- LCD backlight (NS3K) */

	msg_init((void *)argv);
	msg_puts("XXXXXXX hello world XXXXXXX\n");
	if ((argc > 1) && argv[1] ) {
		if (!strcmp(argv[1], "blon")) {
			__gpio_as_output(pin);
			__gpio_set_pin(pin);
		} else if (!strcmp(argv[1], "bloff")) {
			__gpio_as_output(pin);
			__gpio_clear_pin(pin);
		}
	}

	msg_puts("argc = ");
	msg_put_hex(argc);
	msg_puts("\nargv :");
	msg_put_hex(argv);
	msg_puts("\nproc_func addr :");
	msg_put_hex(get_proc_func());
	msg_puts("\n");
#if 1
	for (i=0; i<10; i++) {
		msg_proc();
	}
#endif
	return;	
}
